import os

# This script goes through all jpegs in the render dir and makes movies from them

tempf = '/tmp/videoRender.temp'
exrFolders = '/tmp/videoRenderFiles.temp'

search = '/shared/render/'

ONLY_UPDATE = 0
RENDER = 0
def main():
	
	first_frame = 1
	
	os.system('find %s > %s' % (search, exrFolders))

	file_exrFolders = open(exrFolders, 'r').readlines()
	file_exrFolders.sort()
	
	dirs = {}
	
	errors = {}
	error_count = 0
	tot = len(file_exrFolders)
	
	# Get all folders containing jpegs
	for i, line in enumerate(file_exrFolders):
		line = line.strip()
		if line.lower().endswith('.exr') and '/exr/' in line and '/old/' not in line:
			
			#print 'Loading', line, str(int( (float(i)/tot) * 100.0 )) + '% done,  error count:', error_count
			moviedir, filename = line.split('/exr/')
			moviedir += '/exr/'
			#jpgdir = jpgdir + '/jpg/'
			
			# Ok we have a path containing jpegs 
			# /shared/render/05_throwing/10/jpg/foo.jpg
			
			# Add a list for this folder if its not there.
			if '05_throwing' in moviedir:
				dirs.setdefault(moviedir, []).append(filename)
	
	# Now render the frames
	import Blender
	Blender.Scene.Render.EnableDispView() 
	
	sce = Blender.Scene.GetCurrent()
	seq = sce.sequence
	
	# Settings for all scenes

	rend = sce.render
	rend.oversampling = True
	
	rend.OSALevel = 16 # We dont want to set this now.
	rend.threads = 2
	
	rend.motionBlur = False
	rend.fieldRendering = False
	
	rend.extensions = 1
	rend.renderwinSize = 100
	
	#rend.enableSky()
	#rend.enablePremultiply()
	#rend.enableKey()
	
	#rend.enableBWColor()
	rend.enableRGBColor()
	#rend.enableRGBAColor()
	
	rend.compositor = False
	rend.sequencer = True

	
	rend.xParts = 6
	rend.yParts = 6
	
	rend.fps = 24
	
	rend.touch = False
	rend.noOverwrite =False
	
	rend.imageType = Blender.Scene.Render.AVIJPEG
	
	
	for moviedir, files in sorted(dirs.items()):
		if len(files) > 1:
			#### fname = jpgdir.split('/')[-4] + '_' + jpgdir.split('/')[-3]
			
			fname =   moviedir.split('/')[-4].split('_')[0] + '_' + moviedir.split('/')[-3]
			
			fname_avi = '%s../../%s.avi' % (moviedir, fname)
			fname_avi_hi = '%s../../%s_hi.avi' % (moviedir, fname)
			
			# Check if we need to render the avi, is the avi older then any of the exr's?
			if ONLY_UPDATE:
				mtime = -1
				for f in files:
					name = os.path.join(moviedir, f)
					mtime = max(mtime, os.stat(name)[8])
				
				try:	mtime_hi = os.stat(fname_avi_hi)[8]
				except:	mtime_hi = -1
			
				try:	mtime_low = os.stat(fname_avi)[8]
				except:	mtime_low = -1
			
				print mtime, mtime_hi, mtime_low
			else:
				mtime = 0
				mtime_hi = mtime_low = -1
				
			if not ONLY_UPDATE or (mtime_hi < mtime or mtime_low < mtime):
				
				files.sort()
				
				strip = seq.new( (moviedir, files), first_frame, 1 )
				strip.name = fname
				#seq.start = first_frame
			
				# print fname 
				
				if RENDER:
					rend.sFrame= first_frame
					rend.eFrame= first_frame + (len(files) - 1)
					
					if mtime_hi < mtime:				
						rend.renderPath = fname_avi_hi
						rend.quality(95)			
						rend.sizeX = 1920
						rend.sizeY = 1080
						rend.renderAnim()
					
					if mtime_low < mtime:			
						rend.renderPath = fname_avi
						rend.quality(60)
						rend.sizeX = 960
						rend.sizeY = 540
						rend.renderAnim()
			
			first_frame += len(files)
	
	os.system('rm ' + exrFolders)

main()
		
		
		
		